"""init db

Revision ID: 2cad88d938f1
Revises: 
Create Date: 2023-01-15 14:56:29.929937

"""
import sqlalchemy as sa
import sqlmodel
from alembic import op

# revision identifiers, used by Alembic.
revision = "2cad88d938f1"
down_revision = None
branch_labels = None
depends_on = None


def _has_table(name: str) -> bool:
    from sqlalchemy.engine.reflection import Inspector

    insp = Inspector.from_engine(op.get_bind())
    return name in insp.get_table_names()


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    if _has_table("chatrecorder_message_record"):
        op.rename_table(
            "chatrecorder_message_record", "nonebot_plugin_chatrecorder_messagerecord"
        )
    else:
        op.create_table(
            "nonebot_plugin_chatrecorder_messagerecord",
            sa.Column("id", sa.Integer(), nullable=False),
            sa.Column("platform", sqlmodel.sql.sqltypes.AutoString(), nullable=False),
            sa.Column("time", sa.DateTime(), nullable=False),
            sa.Column("type", sqlmodel.sql.sqltypes.AutoString(), nullable=False),
            sa.Column(
                "detail_type", sqlmodel.sql.sqltypes.AutoString(), nullable=False
            ),
            sa.Column("message_id", sqlmodel.sql.sqltypes.AutoString(), nullable=False),
            sa.Column("message", sqlmodel.sql.sqltypes.AutoString(), nullable=False),
            sa.Column(
                "alt_message", sqlmodel.sql.sqltypes.AutoString(), nullable=False
            ),
            sa.Column("user_id", sqlmodel.sql.sqltypes.AutoString(), nullable=False),
            sa.Column("group_id", sqlmodel.sql.sqltypes.AutoString(), nullable=True),
            sa.PrimaryKeyConstraint("id"),
        )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("nonebot_plugin_chatrecorder_messagerecord")
    # ### end Alembic commands ###
